	format binary
	use32

macro show_addr title,addr
{
	local s,d
	s = addr
	display title,': 0x'
	repeat 4
		d = 48 + s shr ((4-%) shl 2) and 15
		if d>57
			d = d+65-57-1
		end if
		display d
	end repeat
	display 13,10
}

	dd	unpacker-unpacker
	db	1
	dd	unpacker-getbit		; size of getbit procedure

; code of unpacker begins here

getbit:
	add	dl, dl
	jnz	@f
	mov	dl, [esi]
	inc	esi
	adc	dl, dl
@@:	ret

unpacker:
	push	'4'
	pop	edi
	mov	dl, 80h
literal:
	movsb
	mov	dh, 0C1h
nexttag:
	call	ebx
	jnc	literal
	xor	eax, eax
	call	ebx
	jnc	codepair
	call	ebx
	jnc	shortmatch
	mov	dh, 0C1h
	inc	ecx
	mov	al, 10h
@@:
	call	ebx
	adc	al, al
	jnc	@b
	jnz	domatch
	stosb
	dec	ecx
	jmp	nexttag
shortmatch:
	lodsb
	shr	eax, 1
	jz	done
	adc	ecx, ecx
	jmp	domatch_with_2inc
l1:
	jns	domatch_lastpos
	sbb	ecx, 1
	jz	getgamma
	xchg	eax, ecx
	dec	eax
	shl	eax, 8
	lodsb
	mov	dh, 0
codepair:
getgamma:
;	xor	ecx, ecx	; at this moment already ecx=0
	inc	ecx
@@:
	call	ebx
	adc	ecx, ecx
	call	ebx
	jc	@b
	add	dh, dh
	jnz	l1
normalcodepair:
; following 2 or 4 commands are deleted by packer code if file is small
show_addr 'optimize',$
	cmp	eax, 32000
	jae	domatch_with_2inc
	cmp	ah, 5
	jae	domatch_with_inc
	cmp	eax, 7Fh
	ja	domatch_new_lastpos
domatch_with_2inc:
	inc	ecx
domatch_with_inc:
	inc	ecx
domatch_new_lastpos:
	xchg	eax, ebp
domatch_lastpos:
	mov	eax, ebp
	mov	dh, 41h
domatch:
	push	esi
	mov	esi, edi
	sub	esi, eax
	rep	movsb
	pop	esi
	jmp	nexttag
done:
show_addr 'size',done - getbit
